/*!
 * Copyright (c) 2012 - 2020, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  var define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"5cc578079d": function _(e,o,s){Object.defineProperty(s,"__esModule",{value:!0});const r=e("a10314bc5f");e("@bokehjs/base").register_models({MeasureTool:r.MeasureTool})},
"a10314bc5f": function _(e,t,s){Object.defineProperty(s,"__esModule",{value:!0});const a=e("tslib"),i=e("@bokehjs/models/tools/edit/edit_tool"),n=e("@bokehjs/models/annotations/label"),_=a.__importStar(e("@bokehjs/core/properties")),o=e("@bokehjs/core/util/object"),l=e("@bokehjs/styles/icons"),r=e("@bokehjs/models/annotations/annotation"),d=a.__importStar(e("@bokehjs/core/property_mixins"));class h extends r.AnnotationView{connect_signals(){super.connect_signals(),this.connect(this.model.change,()=>this.plot_view.request_paint(this))}_render(){if(!this.model.visible)return;const{ctx:e}=this.layer;e.save(),e.beginPath(),this.visuals.line.set_value(e),e.moveTo(this.model.x_start,this.model.y_start),e.lineTo(this.model.x_end,this.model.y_end),e.stroke(),e.restore()}}s.LineMeasureView=h,h.__name__="LineMeasureView";class m extends r.Annotation{constructor(e){super(e)}static init_LineMeasure(){this.prototype.default_view=h,this.mixins(d.Line),this.define({x_start:[_.Number],x_end:[_.Number],y_start:[_.Number],y_end:[_.Number]})}}s.LineMeasure=m,m.__name__="LineMeasure",m.init_LineMeasure();class u extends i.EditToolView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.active.change,()=>this._active_change())}_active_change(){this.model.active||this._reset_measure_band()}_reset_measure_band(){this.model.measure_band.scale.x_start=0,this.model.measure_band.scale.y_start=0,this.model.measure_band.scale.x_end=0,this.model.measure_band.scale.y_end=0,this.model.measure_band.label.text="",this.model.measure_band.pos_label.text=""}_move(e){const{sx:t,sy:s}=e,{frame:a}=this.plot_view,i=a.x_scale.invert(t),n=a.y_scale.invert(s);this.model.measure_band.pos_label.text="x="+Number(i).toFixed(3)+" "+this.model.measure_unit+", y="+Number(n).toFixed(3)+" "+this.model.measure_unit}_move_exit(e){this.model.measure_band.pos_label.text=""}_tap(e){this._reset_measure_band()}_pan_start(e){const{sx:t,sy:s}=e;this.model.measure_band.scale.x_start=t,this.model.measure_band.scale.y_start=s}_pan(e){if(!this.model.active)return;const{sx:t,sy:s}=e,{frame:a}=this.plot_view;this.model.measure_band.scale.x_end=t,this.model.measure_band.scale.y_end=s;const i=a.x_scale.invert(t),n=a.y_scale.invert(s),_=i-a.x_scale.invert(this.model.measure_band.scale.x_start),o=n-a.y_scale.invert(this.model.measure_band.scale.y_start),l=Math.sqrt(_*_+o*o),r=Math.atan2(o,_),d=180*r/Math.PI;this.model.measure_band.label.text="distance="+Number(l).toFixed(3)+" "+this.model.measure_unit+", angle= "+Number(d).toFixed(2)+"° ("+Number(r).toFixed(2)+" rad)"}}s.MeasureToolView=u,u.__name__="MeasureToolView";class c extends i.EditTool{constructor(e){super(e),this.tool_name="Measure",this.icon=l.bk_tool_icon_range,this.event_type=["tap","pan","move","scroll"]}static init_MeasureTool(){this.prototype.default_view=u,this.define({measure_unit:[_.String,""],line_dash:[_.Array,[4,4]],line_color:[_.Color,"black"],line_width:[_.Number,1.5],line_alpha:[_.Number,1]}),this.internal({measure_band:[_.Any]}),this.register_alias("measure",()=>new c)}get synthetic_renderers(){return o.values(this.measure_band)}initialize(){super.initialize(),this.measure_band={scale:new m({x_start:0,y_start:0,x_end:0,y_end:0,line_dash:this.line_dash,line_color:this.line_color,line_width:this.line_width,line_alpha:this.line_alpha}),label:new n.Label({x:10,y:35,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"}),pos_label:new n.Label({x:10,y:10,x_units:"screen",y_units:"screen",text:"",text_font_size:"18px",background_fill_alpha:.75,background_fill_color:"white"})}}}s.MeasureTool=c,c.__name__="MeasureTool",c.init_MeasureTool()},
}, "5cc578079d", {"index":"5cc578079d","measuretool":"a10314bc5f"}, {});
})

